<?php
/**
* @package Joomla
* @subpackage Servired
* -------------------------------------------------------------------------------------
* @copyright Copyright (C) 2008 Barnatech S.L. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function CalculateTransactionSignature($strOrderId, $dblAmount, $strSignData) {
	global $ServiredConfig;

	if (!function_exists('sha1'))
		require_once(dirname(__FILE__).'/sha1.php');

	// Obtain transaction fields.
	$mixTransaction = Array();
	$mixTransaction['Amount'] = strval(intval($dblAmount * 100));
	$mixTransaction['Amount'] = str_pad($mixTransaction['Amount'], 1, '0', STR_PAD_LEFT);
	$mixTransaction['OrderId'] = str_pad($strOrderId, 12, '0', STR_PAD_LEFT);
	$strMessage = $mixTransaction['Amount'].$mixTransaction['OrderId'].$ServiredConfig['Code'].$ServiredConfig['Currency'].$strSignData.$ServiredConfig['SecretKey'];
	$mixTransaction['Signature'] = strtoupper(sha1($strMessage));

	return $mixTransaction;
}

function PushLanguage(&$mixLangs, $strLang) {
	if (!empty($strLang)) {
		$mixLang = preg_split('/[-_]/', $strLang);
		if (count($mixLang) == 2)
			$strLang = (strtolower(trim($mixLang[0])) == 'es' ? $mixLang[1] : $mixLang[0]);
		$strLang = strtolower(trim($strLang));
		if (!empty($strLang) && !in_array($strLang, $mixLangs))
			array_push($mixLangs, $strLang);
	}
	return $mixLangs;
}

function ConfigureLanguage() {
	global $ServiredConfig, $mosConfig_lang;

	if ($ServiredConfig['ConsumerLanguage'] === '0' || empty($ServiredConfig['ConsumerLanguage'])) {

		// Idiomas reconocidos.
		$mixAcceptedLangs = Array(
			'001' => Array(
				'es', 'spa',
				'spanish',
				'español'
			),
			'002' => Array(
				'en', 'us', 'eng',
				'english',
				'ingles', 'inglés'
			),
			'003' => Array(
				'ca', 'cat',
				'catalan',
				'catalan', 'catalán',
				'catala', 'català'
			),
			'004' => Array(
				'fr', 'fre', 'fra',
				'french',
				'frances', 'francés',
				'francais', 'français'
			),
			'005' => Array(
				'de', 'ger', 'deu',
				'german',
				'aleman', 'alemán',
				'deutsch', 'deutsche'
			),
			'006' => Array(
				'nl', 'dut', 'nld',
				'dutch', 'hollandic', 'hollandish',
				'neerlandes', 'neerlandés', 'holandes', 'holandés',
				'nederlands', 'hollands'
			),
			'007' => Array(
				'it', 'ita',
				'italian',
				'italiano',
				'italiano'
			),
			'008' => Array(
				'sv', 'swe',
				'swedish',
				'sueco',
				'svenska'
			),
			'009' => Array(
				'pt', 'por',
				'portuguese',
				'portugues', 'portugués',
				'portugues', 'português'
			),
			'010' => Array(
				'vl', 'val',
				'valencian',
				'valenciano',
				'valencia', 'valencià'
			),
			'011' => Array(
				'pl', 'pol',
				'polish',
				'polaco',
				'polski'
			),
			'012' => Array(
				'gl', 'glg',
				'galician',
				'gallego',
				'galego'
			),
			'013' => Array(
				'eu', 'eus', 'baq',
				'basque',
				'euskera',
				'euskara'
			)
		);

		// Nombres de idioma candidatos.
		$mixLangs = Array();

		// Idioma de JoomFish.
		if (isset($_COOKIE['jfcookie'])) {
			$mixCookie = $_COOKIE['jfcookie'];
			if (isset($mixCookie['lang']))
				PushLanguage($mixLangs, $mixCookie['lang']);
		}

		// Idioma de Joomla.
		if (isset($_GET['lang']))
			PushLanguage($mixLangs, $_GET['lang']);
		PushLanguage($mixLangs, $mosConfig_lang);
		
		// Idioma del navegador.
		if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) && !empty($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
			$mixLang = preg_split('/[,;]/', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
			foreach($mixLang as $strLang) {
				if (strpos($strLang, '=') === false)
					PushLanguage($mixLangs, $strLang);
			}
		}

		// Comprueba si alguno se encuentra entre los nombres de idioma reconocidos.
		foreach ($mixLangs as $strLang) {
			foreach ($mixAcceptedLangs as $strAcceptedLang => $mixAcceptedLang) {
				if (in_array($strLang, $mixAcceptedLang)) {
					$ServiredConfig['ConsumerLanguage'] = $strAcceptedLang;
					break 2;
				}
			}
		}
	}

	// Formatea el parámetro.
	$ServiredConfig['ConsumerLanguage'] = substr(str_pad(strval($ServiredConfig['ConsumerLanguage']), 3, '0', STR_PAD_LEFT), 0, 3);

}

?>
