﻿<?php
/**
* @package Joomla
* @subpackage Servired
* -------------------------------------------------------------------------------------
* @copyright Copyright (C) 2008 Barnatech S.L. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

define('SHA1_COMPLETE', 1);
define('SHA1_COMPLETE_EXTENDED', 2);

global $ServiredConfig, $mosConfig_absolute_path, $mosConfig_live_site, $database;

require(dirname(__FILE__).DIRECTORY_SEPARATOR.'functions.php');

// Obtiene los parámetros de configuración del componente.

$strComponent = basename(dirname(__FILE__));

if (class_exists('JFactory')) {
	// Joomla 1.5 y superior.
	global $user;
	$user = JFactory::getUser();
	$component = JComponentHelper::getComponent( $strComponent );
	$params = new JParameter( $component->params );
} else {
	// Joomla 1.0.
	$query = "SELECT a.id"
	. "\n FROM #__components AS a"
	. "\n WHERE ( a.admin_menu_link = 'option=".$strComponent."' )"
	. "\n AND a.option = '".$strComponent."'"
	;
	$database->setQuery( $query );
	$id = $database->loadResult();
	$component = new mosComponent( $database );
	$component->load( (int)$id );
	$params = new mosParameters( $component->params );
}
$ServiredConfig = $params->toArray();

$ServiredConfig['URLPath'] = $mosConfig_live_site.'/components/'.$strComponent;

if ($ServiredConfig['TestOnly']) {
	// URL de Sermepa para pruebas.
	$ServiredConfig['URLTPV'] = 'https://sis-t.sermepa.es:25443/sis/realizarPago';
} else {
	// URL de Sermepa para entorno real.
	$ServiredConfig['URLTPV'] = 'https://sis.sermepa.es/sis/realizarPago';
}

// Ajuste del formato de ciertos parámetros.
$ServiredConfig['Terminal'] = substr(strval($ServiredConfig['Terminal']), 0, 1);
$ServiredConfig['Currency'] = substr(strval($ServiredConfig['Currency']), 0, 4);

foreach(Array('OnSuccessURL', 'OnCancelURL') as $strUrl) {
	if (!$ServiredConfig[$strUrl])
		$ServiredConfig[$strUrl] = 'index.php';
	if (strpos($ServiredConfig[$strUrl], '/') === false)
		$ServiredConfig[$strUrl] = $mosConfig_live_site.'/'.$ServiredConfig[$strUrl];
}

// Petición de autorización de pago.
$ServiredConfig['OperationType'] = '0';

// URL de retorno o notificación del comerciante.
// Para poder definir una URL de retorno o notificación es necesario PHP5.
$ServiredConfig['URLMerchant'] = $ServiredConfig['URLPath'].'/notify.php';

// Parámetro para distinguir si nos encontramos en una página de retorno del pago.
if (isset($_GET['print']))
	$ServiredConfig['PaymentStatus'] = 'PRINT_ORDER';
else if (!isset($_GET['ok']))
	$ServiredConfig['PaymentStatus'] = false;
else if ($_GET['ok'])
	$ServiredConfig['PaymentStatus'] = 'OK';
else if (!$_GET['ok'])
	$ServiredConfig['PaymentStatus'] = 'KO';

?>